    001    /* ========================================================================
    002     * JCommon : a free general purpose class library for the Java(tm) platform
    003     * ========================================================================
    004     *
    005     * (C) Copyright 2000-2005, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jcommon/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * -------------------------
    028     * DayOfWeekInMonthRule.java
    029     * -------------------------
    030     * (C) Copyright 2000-2003, by Object Refinery Limited.
    031     *
    032     * Original Author:  David Gilbert (for Object Refinery Limited);
    033     * Contributor(s):   -;
    034     *
    035     * $Id: DayOfWeekInMonthRule.java,v 1.4 2005/10/18 13:15:08 mungady Exp $
    036     *
    037     * Changes (from 26-Oct-2001)
    038     * --------------------------
    039     * 26-Oct-2001 : Changed package to com.jrefinery.date.*;
    040     * 03-Oct-2002 : Fixed errors reported by Checkstyle (DG);
    041     * 01-Jun-2005 : Removed the explicit clonable declaration, it is declared
    042     *               in the super class.
    043     */
    044
    045    package org.jfree.date;
    046
    047    /**
    048     * An annual date rule that specifies the nth day of the week in a given month
    049     * (for example, the third Wednesday in June, or the last Friday in November).
    050     *
    051     * @author David Gilbert
    052     */
    053    public class DayOfWeekInMonthRule extends AnnualDateRule {
    054
    055        /** FIRST, SECOND, THIRD, FOURTH or LAST. */
    056        private int count;
    057
    058        /** The day of the week (SerialDate.MONDAY, SerialDate.TUESDAY...). */
    059        private int dayOfWeek;
    060
    061        /** The month (1 to 12, or SerialDate.JANUARY, SerialDate.FEBRUARY...). */
    062        private int month;
    063
    064        /**
    065         * Default constructor: builds a rule for the first Monday in January by default.
    066         */
    067        public DayOfWeekInMonthRule() {
    068            this(1, SerialDate.MONDAY, MonthConstants.JANUARY);
    069        }
    070
    071        /**
    072         * Standard constructor: builds a rule with the specified attributes.
    073         *
    074         * @param count  one of: FIRST, SECOND, THIRD, FOURTH or LAST.
    075         * @param dayOfWeek  the day-of-the-week (SerialDate.MONDAY, SerialDate.TUESDAY, etc.).
    076         * @param month  the month (SerialDate.JANUARY, SerialDate.FEBRUARY, etc.).
    077         */
    078        public DayOfWeekInMonthRule(final int count, final int dayOfWeek, final int month) {
    079            this.count = count;
    080            this.dayOfWeek = dayOfWeek;
    081            this.month = month;
    082        }
    083
    084        /**
    085         * Returns the 'count' for this rule (one of FIRST, SECOND, THIRD, FOURTH and LAST).
    086         *
    087         * @return the 'count'.
    088         */
    089        public int getCount() {
    090            return this.count;
    091        }
    092
    093        /**
    094         * Sets the 'count' for this rule (one of FIRST, SECOND, THIRD, FOURTH and LAST).
    095         *
    096         * @param count the 'count'.
    097         */
    098        public void setCount(final int count) {
    099            this.count = count;
    100        }
    101
    102        /**
    103         * Returns the day-of-the-week for this rule (SerialDate.MONDAY, SerialDate.TUESDAY, etc.).
    104         *
    105         * @return the day-of-the-week.
    106         */
    107        public int getDayOfWeek() {
    108            return this.dayOfWeek;
    109        }
    110
    111        /**
    112         * Sets the day-of-the-week for this rule.
    113         *
    114         * @param dayOfWeek  the day-of-the-week.
    115         */
    116        public void setDayOfWeek(final int dayOfWeek) {
    117            this.dayOfWeek = dayOfWeek;
    118        }
    119
    120        /**
    121         * Returns the month for this rule.
    122         *
    123         * @return the month.
    124         */
    125        public int getMonth() {
    126            return this.month;
    127        }
    128
    129        /**
    130         * Sets the month for this rule.
    131         *
    132         * @param month  the month (SerialDate.JANUARY, SerialDate.FEBRUARY, etc.).
    133         */
    134        public void setMonth(final int month) {
    135            this.month = month;
    136        }
    137
    138        /**
    139         * Return the date for this rule, given the year.
    140         *
    141         * @param year  the year.
    142         *
    143         * @return the date generated by the rule for the given year.
    144         */
    145        public SerialDate getDate(final int year) {
    146            SerialDate result;
    147            if (this.count != SerialDate.LAST_WEEK_IN_MONTH) {
    148                // start at the beginning of the month
    149                result = SerialDate.createInstance(1, this.month, year);
    150                while (result.getDayOfWeek() != this.dayOfWeek) {
    151                    result = SerialDate.addDays(1, result);
    152                }
    153                result = SerialDate.addDays(7 * (this.count - 1), result);
    154
    155            }
    156            else {
    157                // start at the end of the month and work backwards...
    158                result = SerialDate.createInstance(1, this.month, year);
    159                result = result.getEndOfCurrentMonth(result);
    160                while (result.getDayOfWeek() != this.dayOfWeek) {
    161                    result = SerialDate.addDays(-1, result);
    162                }
    163
    164            }
    165            return result;
    166        }
    167
    168    }